drm/nouveau: consume the return of large GSP message
[drm/drm-misc.git] / tools / perf / tests / shell / lock_contention.sh
blob30d195d4c62f74d09c0b7d02928c28681bcedf10
1 #!/bin/sh
2 # kernel lock contention analysis test
3 # SPDX-License-Identifier: GPL-2.0
5 set -e
7 err=0
8 perfdata=$(mktemp /tmp/__perf_test.perf.data.XXXXX)
9 result=$(mktemp /tmp/__perf_test.result.XXXXX)
11 cleanup() {
12 rm -f ${perfdata}
13 rm -f ${result}
14 trap - EXIT TERM INT
17 trap_cleanup() {
18 cleanup
19 exit ${err}
21 trap trap_cleanup EXIT TERM INT
23 check() {
24 if [ "$(id -u)" != 0 ]; then
25 echo "[Skip] No root permission"
26 err=2
27 exit
30 if ! perf list tracepoint | grep -q lock:contention_begin; then
31 echo "[Skip] No lock contention tracepoints"
32 err=2
33 exit
36 # shellcheck disable=SC2046
37 if [ `nproc` -lt 4 ]; then
38 echo "[Skip] Low number of CPUs (`nproc`), lock event cannot be triggered certainly"
39 err=2
40 exit
44 test_record()
46 echo "Testing perf lock record and perf lock contention"
47 perf lock record -o ${perfdata} -- perf bench sched messaging > /dev/null 2>&1
48 # the output goes to the stderr and we expect only 1 output (-E 1)
49 perf lock contention -i ${perfdata} -E 1 -q 2> ${result}
50 if [ "$(cat "${result}" | wc -l)" != "1" ]; then
51 echo "[Fail] Recorded result count is not 1:" "$(cat "${result}" | wc -l)"
52 err=1
53 exit
57 test_bpf()
59 echo "Testing perf lock contention --use-bpf"
61 if ! perf lock con -b true > /dev/null 2>&1 ; then
62 echo "[Skip] No BPF support"
63 return
66 # the perf lock contention output goes to the stderr
67 perf lock con -a -b -E 1 -q -- perf bench sched messaging > /dev/null 2> ${result}
68 if [ "$(cat "${result}" | wc -l)" != "1" ]; then
69 echo "[Fail] BPF result count is not 1:" "$(cat "${result}" | wc -l)"
70 err=1
71 exit
75 test_record_concurrent()
77 echo "Testing perf lock record and perf lock contention at the same time"
78 perf lock record -o- -- perf bench sched messaging 2> /dev/null | \
79 perf lock contention -i- -E 1 -q 2> ${result}
80 if [ "$(cat "${result}" | wc -l)" != "1" ]; then
81 echo "[Fail] Recorded result count is not 1:" "$(cat "${result}" | wc -l)"
82 err=1
83 exit
87 test_aggr_task()
89 echo "Testing perf lock contention --threads"
90 perf lock contention -i ${perfdata} -t -E 1 -q 2> ${result}
91 if [ "$(cat "${result}" | wc -l)" != "1" ]; then
92 echo "[Fail] Recorded result count is not 1:" "$(cat "${result}" | wc -l)"
93 err=1
94 exit
97 if ! perf lock con -b true > /dev/null 2>&1 ; then
98 return
101 # the perf lock contention output goes to the stderr
102 perf lock con -a -b -t -E 1 -q -- perf bench sched messaging > /dev/null 2> ${result}
103 if [ "$(cat "${result}" | wc -l)" != "1" ]; then
104 echo "[Fail] BPF result count is not 1:" "$(cat "${result}" | wc -l)"
105 err=1
106 exit
110 test_aggr_addr()
112 echo "Testing perf lock contention --lock-addr"
113 perf lock contention -i ${perfdata} -l -E 1 -q 2> ${result}
114 if [ "$(cat "${result}" | wc -l)" != "1" ]; then
115 echo "[Fail] Recorded result count is not 1:" "$(cat "${result}" | wc -l)"
116 err=1
117 exit
120 if ! perf lock con -b true > /dev/null 2>&1 ; then
121 return
124 # the perf lock contention output goes to the stderr
125 perf lock con -a -b -l -E 1 -q -- perf bench sched messaging > /dev/null 2> ${result}
126 if [ "$(cat "${result}" | wc -l)" != "1" ]; then
127 echo "[Fail] BPF result count is not 1:" "$(cat "${result}" | wc -l)"
128 err=1
129 exit
133 test_aggr_cgroup()
135 echo "Testing perf lock contention --lock-cgroup"
137 if ! perf lock con -b true > /dev/null 2>&1 ; then
138 echo "[Skip] No BPF support"
139 return
142 # the perf lock contention output goes to the stderr
143 perf lock con -a -b -g -E 1 -q -- perf bench sched messaging > /dev/null 2> ${result}
144 if [ "$(cat "${result}" | wc -l)" != "1" ]; then
145 echo "[Fail] BPF result count is not 1:" "$(cat "${result}" | wc -l)"
146 err=1
147 exit
151 test_type_filter()
153 echo "Testing perf lock contention --type-filter (w/ spinlock)"
154 perf lock contention -i ${perfdata} -Y spinlock -q 2> ${result}
155 if [ "$(grep -c -v spinlock "${result}")" != "0" ]; then
156 echo "[Fail] Recorded result should not have non-spinlocks:" "$(cat "${result}")"
157 err=1
158 exit
161 if ! perf lock con -b true > /dev/null 2>&1 ; then
162 return
165 perf lock con -a -b -Y spinlock -q -- perf bench sched messaging > /dev/null 2> ${result}
166 if [ "$(grep -c -v spinlock "${result}")" != "0" ]; then
167 echo "[Fail] BPF result should not have non-spinlocks:" "$(cat "${result}")"
168 err=1
169 exit
173 test_lock_filter()
175 echo "Testing perf lock contention --lock-filter (w/ tasklist_lock)"
176 perf lock contention -i ${perfdata} -l -q 2> ${result}
177 if [ "$(grep -c tasklist_lock "${result}")" != "1" ]; then
178 echo "[Skip] Could not find 'tasklist_lock'"
179 return
182 perf lock contention -i ${perfdata} -L tasklist_lock -q 2> ${result}
184 # find out the type of tasklist_lock
185 test_lock_filter_type=$(head -1 "${result}" | awk '{ print $8 }' | sed -e 's/:.*//')
187 if [ "$(grep -c -v "${test_lock_filter_type}" "${result}")" != "0" ]; then
188 echo "[Fail] Recorded result should not have non-${test_lock_filter_type} locks:" "$(cat "${result}")"
189 err=1
190 exit
193 if ! perf lock con -b true > /dev/null 2>&1 ; then
194 return
197 perf lock con -a -b -L tasklist_lock -q -- perf bench sched messaging > /dev/null 2> ${result}
198 if [ "$(grep -c -v "${test_lock_filter_type}" "${result}")" != "0" ]; then
199 echo "[Fail] BPF result should not have non-${test_lock_filter_type} locks:" "$(cat "${result}")"
200 err=1
201 exit
205 test_stack_filter()
207 echo "Testing perf lock contention --callstack-filter (w/ unix_stream)"
208 perf lock contention -i ${perfdata} -v -q 2> ${result}
209 if [ "$(grep -c unix_stream "${result}")" = "0" ]; then
210 echo "[Skip] Could not find 'unix_stream'"
211 return
214 perf lock contention -i ${perfdata} -E 1 -S unix_stream -q 2> ${result}
215 if [ "$(cat "${result}" | wc -l)" != "1" ]; then
216 echo "[Fail] Recorded result should have a lock from unix_stream:" "$(cat "${result}")"
217 err=1
218 exit
221 if ! perf lock con -b true > /dev/null 2>&1 ; then
222 return
225 perf lock con -a -b -S unix_stream -E 1 -q -- perf bench sched messaging > /dev/null 2> ${result}
226 if [ "$(cat "${result}" | wc -l)" != "1" ]; then
227 echo "[Fail] BPF result should have a lock from unix_stream:" "$(cat "${result}")"
228 err=1
229 exit
233 test_aggr_task_stack_filter()
235 echo "Testing perf lock contention --callstack-filter with task aggregation"
236 perf lock contention -i ${perfdata} -v -q 2> ${result}
237 if [ "$(grep -c unix_stream "${result}")" = "0" ]; then
238 echo "[Skip] Could not find 'unix_stream'"
239 return
242 perf lock contention -i ${perfdata} -t -E 1 -S unix_stream -q 2> ${result}
243 if [ "$(cat "${result}" | wc -l)" != "1" ]; then
244 echo "[Fail] Recorded result should have a task from unix_stream:" "$(cat "${result}")"
245 err=1
246 exit
249 if ! perf lock con -b true > /dev/null 2>&1 ; then
250 return
253 perf lock con -a -b -t -S unix_stream -E 1 -q -- perf bench sched messaging > /dev/null 2> ${result}
254 if [ "$(cat "${result}" | wc -l)" != "1" ]; then
255 echo "[Fail] BPF result should have a task from unix_stream:" "$(cat "${result}")"
256 err=1
257 exit
260 test_cgroup_filter()
262 echo "Testing perf lock contention --cgroup-filter"
264 if ! perf lock con -b true > /dev/null 2>&1 ; then
265 echo "[Skip] No BPF support"
266 return
269 perf lock con -a -b -g -E 1 -F wait_total -q -- perf bench sched messaging > /dev/null 2> ${result}
270 if [ "$(cat "${result}" | wc -l)" != "1" ]; then
271 echo "[Fail] BPF result should have a cgroup result:" "$(cat "${result}")"
272 err=1
273 exit
276 cgroup=$(cat "${result}" | awk '{ print $3 }')
277 perf lock con -a -b -g -E 1 -G "${cgroup}" -q -- perf bench sched messaging > /dev/null 2> ${result}
278 if [ "$(cat "${result}" | wc -l)" != "1" ]; then
279 echo "[Fail] BPF result should have a result with cgroup filter:" "$(cat "${cgroup}")"
280 err=1
281 exit
286 test_csv_output()
288 echo "Testing perf lock contention CSV output"
289 perf lock contention -i ${perfdata} -E 1 -x , --output ${result}
290 # count the number of commas in the header
291 # it should have 5: contended, total-wait, max-wait, avg-wait, type, caller
292 header=$(grep "# output:" ${result} | tr -d -c , | wc -c)
293 if [ "${header}" != "5" ]; then
294 echo "[Fail] Recorded result does not have enough output columns: ${header} != 5"
295 err=1
296 exit
298 # count the number of commas in the output
299 output=$(grep -v "^#" ${result} | tr -d -c , | wc -c)
300 if [ "${header}" != "${output}" ]; then
301 echo "[Fail] Recorded result does not match the number of commas: ${header} != ${output}"
302 err=1
303 exit
306 if ! perf lock con -b true > /dev/null 2>&1 ; then
307 echo "[Skip] No BPF support"
308 return
311 # the perf lock contention output goes to the stderr
312 perf lock con -a -b -E 1 -x , --output ${result} -- perf bench sched messaging > /dev/null 2>&1
313 output=$(grep -v "^#" ${result} | tr -d -c , | wc -c)
314 if [ "${header}" != "${output}" ]; then
315 echo "[Fail] BPF result does not match the number of commas: ${header} != ${output}"
316 err=1
317 exit
321 check
323 test_record
324 test_bpf
325 test_record_concurrent
326 test_aggr_task
327 test_aggr_addr
328 test_aggr_cgroup
329 test_type_filter
330 test_lock_filter
331 test_stack_filter
332 test_aggr_task_stack_filter
333 test_cgroup_filter
334 test_csv_output
336 exit ${err}